Bug 442330 - [patch] x86_64 VDSO has no debug info
[patch] x86_64 VDSO has no debug info
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: kernel (Show other bugs)
9
x86_64 Linux
low Severity low
: ---
: ---
Assigned To: Kernel Maintainer List
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2008-04-14 09:27 EDT by Jan Kratochvil
Modified: 2009-07-14 11:44 EDT (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-07-14 11:44:31 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Fix. (536 bytes, patch)
2008-04-14 09:27 EDT, Jan Kratochvil
no flags Details | Diff

  None (edit)
Description Jan Kratochvil 2008-04-14 09:27:24 EDT
Description of problem:
With recent Rawhide kernels Fedora GDB started to complain on VDSO:
warning:
"/usr/lib/debug/lib/modules/2.6.25-0.172.rc7.git4.fc9.x86_64/vdso/vdso.so.debug":
The separate debug info file has no debug info

Version-Release number of selected component (if applicable):
kernel-debuginfo-2.6.25-0.172.rc7.git4.fc9.x86_64 (broken)
kernel-debuginfo-2.6.25-0.218.rc8.git7.fc9.x86_64 (broken)
(but F-8 kernel-debuginfo-2.6.24.4-64.fc8.x86_64 is still OK)
gdb-6.6-45.fc8.x86_64 OR gdb-6.8-1.fc9.x86_64

How reproducible:
Always.

Steps to Reproduce:
1. yum install kernel-debuginfo
2. gdb -q /bin/true

Actual results:
Using host libthread_db library "/lib64/libthread_db.so.1".
(gdb) run
Starting program: /bin/true 
warning:
"/usr/lib/debug/lib/modules/2.6.25-0.172.rc7.git4.fc9.x86_64/vdso/vdso.so.debug":
The separate debug info file has no debug info

Program exited normally.
(gdb) q


Expected results:
Using host libthread_db library "/lib64/libthread_db.so.1".
(gdb) run
Starting program: /bin/true 

Program exited normally.
(gdb) q


Additional info:
In fact it makes no difference on i686 where it is used for the backtraces and I
admit I did not check how the VDSO is currently used on x86_64.

Still the fix is IMO clear.

Test build was prepared at:
  http://koji.fedoraproject.org/scratch/jkratoch/task_564722/

/usr/lib/debug/lib/modules/*/vdso/vdso.so.debug has more symbols in .symtab than
/lib/modules/*/vdso/vdso.so but none of them has .debug_info while VDSO was
assembled from .c files.

i686 does not seem to have VDSO from .c files so it makes no difference there.
Comment 1 Jan Kratochvil 2008-04-14 09:27:24 EDT
Created attachment 302334 [details]
Fix.
Comment 2 Roland McGrath 2008-04-14 15:40:34 EDT
Similar fix posted upstream: http://marc.info/?l=linux-kernel&m=120820101915033&w=4

The x86_64 vDSO is used far less than the 32-bit x86 vDSO (it's not necessary
for backtraces from syscalls or signals, for example).  So I think the only
trouble for most users is the pesky message from gdb.  If that is enough of a
concern, we can put the patch in rawhide/f9.  If not, just close as UPSTREAM.
Comment 3 Jan Kratochvil 2008-04-14 16:11:15 EDT
(In reply to comment #2)
> So I think the only trouble for most users is the pesky message from gdb.

It is a message from the so-far Fedora-only build-id files-locating patch.

In fact there should be IMO a sanity check in `find-debuginfo.sh' that any
.debug file has some `.debug_info' section (at least with just
`DW_TAG_compile_unit').
Comment 4 Roland McGrath 2008-04-14 16:23:33 EDT
They're still valid if they just have a symtab and no DWARF, technically.
And if that's not the case, the file output won't have "not stripped" and so
they won't be processed.

Still, I think a sanity check of some sort, and even just a warning about no
DWARF, might be reasonable.
Comment 5 Chuck Ebbert 2008-04-29 15:06:38 EDT
Patch is merged in 2.6.26-rc

commit 8705a49c35be088a50b8d5fc5e1aa24d6711fd5b
x86 vDSO: compile with -g, 64-bit

Do we want this in F9?
Comment 6 Jan Kratochvil 2008-04-29 16:10:58 EDT
Yes, it would be nice in F9 just because of that annoying GDB warning, thanks:
warning: "/usr/lib/debug/lib/modules/2.6.25-8.fc9.x86_64/vdso/vdso.so.debug":
The separate debug info file has no debug info
I could patch it in GDB but probably a kernel fix is better.
Comment 7 Bug Zapper 2008-05-14 05:23:44 EDT
Changing version to '9' as part of upcoming Fedora 9 GA.
More information and reason for this action is here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 8 Bug Zapper 2009-06-09 20:10:00 EDT
This message is a reminder that Fedora 9 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 9.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '9'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 9's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 9 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 9 Bug Zapper 2009-07-14 11:44:31 EDT
Fedora 9 changed to end-of-life (EOL) status on 2009-07-10. Fedora 9 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.